using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Serialization;
using System.Reflection;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace GridCrasher
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
        private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        private string[] m_Comments;
        private int[]    m_Ratings;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


            // Setup any default settings
            gridControl1.Cols.DefaultSize = 100;               
            gridControl1.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;                                               
            gridControl1.BaseStylesMap["Column Header"].StyleInfo.Font.Bold = false;
            gridControl1.BaseStylesMap["Row Header"].StyleInfo.Font.Bold = false;

			// Virtual
            gridControl1.ResetVolatileData();
            gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);
            gridControl1.SaveCellInfo  += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
            gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
            gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);                        
            gridControl1.QueryColWidth += new Syncfusion.Windows.Forms.Grid.GridRowColSizeEventHandler(gridControl1_QueryColWidth);            

            //  Data Store...
            m_Ratings  = new int[10] { 1, 2, 3, 4, 5, 5, 4, 3, 2, 1 };
            m_Comments = new string[10] { "one", "two", "three", "four", "five", "five", "four", "three", "two", "one" };

            // Setup any custom controls
            gridControl1.CellModels.Add("RatingCell", new GridRatingCellModel(gridControl1.Model));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.Location = new System.Drawing.Point(8, 8);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.Size = new System.Drawing.Size(424, 184);
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(152, 216);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(136, 23);
            this.button1.TabIndex = 1;
            this.button1.Text = "Populate Grid";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(448, 266);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.gridControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void button1_Click(object sender, System.EventArgs e)
        {
        
        }

        #region Virtual Grid Events        

        private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            e.Count   = 3;
            e.Handled = true;            
        }

        private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {            
            e.Count   = 10;
            e.Handled = true;            
        }

        private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {                   
            // Are we looking for a column header???
            if (e.RowIndex == 0)
            {                    
                switch (e.ColIndex)
                {                    
                    case 1:  
                        e.Style.ReadOnly    = true;   
                        e.Style.Text        = "Display Name";
                        e.Handled           = true; 
                        break;

                    case 2:                                                                             
                        e.Style.ReadOnly    = true;    
                        e.Style.Text        = "Comment";
                        e.Handled           = true;                          
                        break;
                        
                    case 3:                                                
                        e.Style.ReadOnly    = true; 
                        e.Style.Text        = "Rating";                        
                        e.Handled           = true; 
                        break;
                }
            }
            else
            {      
                int offsetIndex = e.RowIndex-1;         
                switch (e.ColIndex)
                {                     
                    case 1:
                        e.Style.ReadOnly    = true; 
                        e.Style.Text        = "Some Name " + offsetIndex.ToString();
                        e.Handled           = true; 
                        break;

                    case 2: 
                        {                            
                            e.Style.ReadOnly    = false;                         
                            e.Style.Text        = m_Comments[offsetIndex];
                            e.Handled           = true; 
                        }
                        break;

                    case 3:
                        {    
                            ValuePair vp = new ValuePair(m_Ratings[offsetIndex], null);
    
                            e.Style.Text        = "";
                            e.Style.CellType    = "RatingCell";
                            e.Style.Tag         = vp;
                            e.Handled           = true; 
                        }
                        break;
                }
            }                                                                         
        }
       
        private void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
        {   
            int offsetIndex = e.RowIndex-1;    
            if (e.ColIndex == 2) // "Comment"
            {
                m_Comments[offsetIndex] = e.Style.Text;                                        
                e.Handled = true;                      
            } 
            else if (e.ColIndex == 3) // "Rating"
            {
                ValuePair vp = (ValuePair)e.Style.Tag;
                m_Ratings[offsetIndex] = (int)vp.A;                                        
                e.Handled = true;                      
            } 
        }

        void gridControl1_QueryColWidth(object sender, GridRowColSizeEventArgs e)
        {              
            switch (e.Index)
            {
                    // Force the first column to be relatively small.. (only needs to be big enough for some simple selection)
                case 0:                
                    e.Size = 30;
                    e.Handled = true;         
                    break;
            }
        }

        #endregion 
	}

    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------

    public class GridRatingCellModel : GridStaticCellModel
    {
        protected GridRatingCellModel(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public GridRatingCellModel(GridModel grid)
            : base(grid)
        {
            AllowFloating = false;
        }
	
        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new GridRatingCellRenderer(control, this);
        }

    }

    /// <summary>
    /// 
    /// </summary>
    public class GridRatingCellRenderer: GridStaticCellRenderer
    {
        private bool m_IsMouseDown;	
        private bool m_IsHot;		
        private uint m_MaxRating;
	
        private Image       m_Image;        
        private ImageList   m_ImageList;
        private bool        m_ShowHotTracking;

        private const string GLYPH_MAPPING_RESOURCE_NAME = "GridCrasher.CCGlyphs.bmp";        

        public GridRatingCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
            m_ShowHotTracking   = false;
            m_IsMouseDown       = false;
            m_IsHot             = false;            
            m_MaxRating         = 5;
			
            Assembly currentAssembly = Assembly.GetExecutingAssembly();
            System.IO.Stream s = currentAssembly.GetManifestResourceStream(GLYPH_MAPPING_RESOURCE_NAME);            

            m_Image = Image.FromStream(s);           
            
            m_ImageList = new ImageList();            
            m_ImageList.TransparentColor = Color.Magenta;
            m_ImageList.ImageSize        = new Size(11, 11);
            m_ImageList.Images.AddStrip(m_Image);                      
        }						

        private void DrawUpdate(int rowIndex, int colIndex)
        {			
            this.Grid.RefreshRange(GridRangeInfo.Cell(rowIndex, colIndex), GridRangeOptions.None);			
        }

        protected override void OnMouseDown(int rowIndex, int colIndex, System.Windows.Forms.MouseEventArgs e)
        {
            m_IsMouseDown = true;
            base.OnMouseDown(rowIndex, colIndex, e);
            DrawUpdate(rowIndex, colIndex);			
        }

        protected override void OnMouseUp(int rowIndex, int colIndex, System.Windows.Forms.MouseEventArgs e)
        {                                  
            m_IsMouseDown = false;

            base.OnMouseUp(rowIndex, colIndex, e);
			
            int row, col;
            this.Grid.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            if(row == rowIndex && col == colIndex)
            {	
                // Get the "Style"
                GridStyleInfo style = this.Grid.Model[row, col];

                // Find the imagesize and offset
                Rectangle cellRect  = this.Grid.RangeInfoToRectangle(GridRangeInfo.Cell(row, col));                
                uint hitPosition    = System.Convert.ToUInt32(e.X - cellRect.Left);
               
                // Test/Set the new rating...
                Size mySize = m_ImageList.ImageSize; 
                int calculatedPostion = 0;
                for(int index=1; index<=m_MaxRating; index++)
                {
                    calculatedPostion += mySize.Width;
                    if (calculatedPostion > hitPosition)
                    {    
                        // Save the value....
                        ValuePair vp = (ValuePair)style.Tag;                        
                        vp.A = index; 

                        Grid.CurrentCell.IsModified = true;                     
                        break;
                    }
                }
            }
            DrawUpdate(rowIndex, colIndex);		
        }

        protected override void OnCancelMode(int rowIndex, int colIndex)
        {
            base.OnCancelMode(rowIndex, colIndex);
            m_IsMouseDown = false;
        }

        protected override System.Windows.Forms.Cursor OnGetCursor(int rowIndex, int colIndex)
        {
            System.Windows.Forms.Cursor retCursor = base.OnGetCursor(rowIndex, colIndex);
            if (m_ShowHotTracking)
            {
                //if over cell, return HandPointerCursor otherwise NoCursor...
                Point pt = this.Grid.PointToClient(Cursor.Position);
        			
                int row, col;
                this.Grid.PointToRowCol(pt, out row, out col);

                retCursor =  (row == rowIndex && col == colIndex ) ? Cursors.Hand : (this.m_IsMouseDown) ? Cursors.No : retCursor;
            }
            return retCursor;
        }

        protected override int OnHitTest(int rowIndex, int colIndex, MouseEventArgs e, IMouseController controller)
        {
            //return a nonzero so the mouse messages will be forwarded to the cell render
            //but don't include the cell borders so D&D can be handled
            if (controller != null && controller.Name == "OleDataSource")
                // other controllers have higher priority than me
                return 0;

            return 1;
            
        }

        protected override void OnDraw(System.Drawing.Graphics g, System.Drawing.Rectangle clientRectangle, int rowIndex, int colIndex, Syncfusion.Windows.Forms.Grid.GridStyleInfo style)
        {	
            // What is the Size of these bad boys?
            Size sizeOfImage = m_ImageList.ImageSize;
            Point pt = new Point(clientRectangle.X, clientRectangle.Y);
                       
            // Get The data...
            ValuePair vp = (ValuePair)style.Tag;

            // Spin through and draw em...
            uint currentRating = System.Convert.ToUInt32(vp.A);
            for(uint index = 0; index < m_MaxRating; index++)
            {  
                // If the index is less than the rating  
                if (index < currentRating)
                {
                    if (m_IsHot == true)
                        g.DrawImage(m_ImageList.Images[0], pt);
                    else
                        g.DrawImage(m_ImageList.Images[2], pt);
                }
                else
                    g.DrawImage(m_ImageList.Images[1], pt);
                
                pt.X += sizeOfImage.Width;
            }            
            
            base.OnDraw(g, clientRectangle, rowIndex, colIndex, style);
        }

        protected override void OnMouseHoverEnter(int rowIndex, int colIndex)
        {
            if (m_ShowHotTracking)
            {
                m_IsHot = true;
                base.OnMouseHoverEnter(rowIndex, colIndex);			
                DrawUpdate(rowIndex, colIndex);
            }
        }

        protected override void OnMouseHoverLeave(int rowIndex, int colIndex, System.EventArgs e)
        {
            if (m_ShowHotTracking)
            {
                m_IsHot = false;
                base.OnMouseHoverLeave(rowIndex, colIndex, e);			
                DrawUpdate(rowIndex, colIndex);
            }
        }
    }

    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------
    //-------------------------------------------------------------------------

    public class ValuePair
    {
        private object m_A;
        private object m_B;

        public ValuePair(object a, object b)
        {
            m_A = a;
            m_B = b;
        }

        public override string ToString()
        {
            return m_A.ToString();
        }

        public object A
        {
            get { return m_A; }
            set { m_A = value; }
        }

        public object B
        {
            get { return m_B; }
            set { m_B = value; }
        }                   
    }
}
